library dborganizer;

import "dart:async";
import "package:sqljocky/sqljocky.dart";

Future<DB> createDB(String host,String username , String password ,String db_name , DB build(DBBuilder dbb)){
  
  Completer completer = new Completer();
  
  ConnectionPool cp = new ConnectionPool(host: host,user: username,password: password);
  cp.getConnection().then((connection){
    DBBuilder dbb = new DBBuilder._(db_name,build,connection,completer);
  });
  
  return completer.future;
}

abstract class DB{
  
  
  
}

class CreateDBSQL{
  CreateDBSQL(){
    
  }
}

class DBBuilder{
  
  String db_name;
  String db_name_with_date;
  List<TableBuilder> _tbs = [];
  
  DBBuilder._(this.db_name,DB f(DBBuilder dbb) ,RetainedConnection connection , Completer completer){
    
    DB db = f(this);
    var dt = new DateTime.now();
    db_name_with_date = "${db_name}_${dt.year}_${dt.month}_${dt.day}_${dt.hour}_${dt.minute}";    
    
    List<String> querys = ["create database `$db_name_with_date`" , "use `$db_name_with_date`"];
    _tbs.forEach((tb) => tb._addQuerys(querys));
    querys.add("#drop database `$db_name_with_date`");
    querys.forEach((str) => print(str + ";"));
    
  }
  
  TableBuilder tableBuilder(String table_name){
    var tb = new TableBuilder._(this , table_name);
    _tbs.add(tb);
    return tb;
  }
  
}

class TableBuilder{

  final DBBuilder dbb;
  final String table_name;
  final List<Column> _cbs = [];
  
  TableBuilder._(this.dbb , this.table_name , {bool deletable : true});
  
  IDColumn id_column(String column_name) => _addColumn(new IDColumn(column_name));
  
  StringColumn string_column(String column_name,{int length : 100}) => _addColumn(new StringColumn(column_name,length));
  
  IntegerColumn intger_column(String column_name,{int min : 0, int max : 100000}) => _addColumn(new IntegerColumn(column_name));
  
  DateTimeColumn datetime_column(String column_name) => _addColumn(new DateTimeColumn(column_name));
  
  ReferenceColumn reference_column(String column_name,ID foreign_table) => _addColumn(new ReferenceColumn(column_name,foreign_table.id));
  
  Column _addColumn(Column column){
    _cbs.add(column);
    return column;
  }
  
  void unique(List<Column> keys){
    
  }
  
  void _addQuerys(List<String>querys){
    querys.add("create table `$table_name`(dummy int) engine = memory");
    _cbs.forEach((cb) => cb._addQuerys(querys,table_name));
    querys.add("alter table `$table_name` drop column dummy");
  }
  
}

abstract class Table{
  
  
  
}

abstract class ID{
  
  IDColumn get id;
  
}

abstract class ID_Name implements ID{
  
  StringColumn get name;
  
}

abstract class Column{
  
  final String column_name;
  Column(this.column_name);
  void _addQuerys(List<String>querys,String table_name);
  
}

class IDColumn extends Column{
  IDColumn(String column_name):super(column_name);
  void _addQuerys(List<String>querys,String table_name){
    querys.add("alter table `$table_name` add column `$column_name` int not null primary key auto_increment");
  }
}

class StringColumn extends Column{
  
  final int _length;
  
  StringColumn(String column_name, this._length):super(column_name);
  void _addQuerys(List<String>querys,String table_name){
    querys.add("alter table `$table_name` add column `$column_name` varchar($_length)");
  }
}

class IntegerColumn extends Column{
  IntegerColumn(String column_name):super(column_name);
  void _addQuerys(List<String>querys,String table_name){
    querys.add("alter table `$table_name` add column `$column_name` int");
  }
}

class DateTimeColumn extends Column{
  DateTimeColumn(String column_name):super(column_name);
  void _addQuerys(List<String>querys,String table_name){
    querys.add("alter table `$table_name` add column `$column_name` datetime");
  }
}

class ReferenceColumn extends Column{
  
  ReferenceColumn(String column_name,IDColumn foreignkey):super(column_name);
  void _addQuerys(List<String>querys,String table_name){
    querys.add("alter table `$table_name` add column `$column_name` int");
  }
  
}
